import java.awt.*;
import java.applet.*;

public class kroha extends Applet implements Runnable
{
  Thread engine;
  boolean run,oneStep,zero,over;
  Button start=new Button("Start"),step=new Button("Step"),clear=new Button("Clear"),no=new Button("N");
  Font font=new Font("Courier",Font.PLAIN,12);
  int i,pc,cx,cy,w,h;
  int mem[]=new int[16];
  int dis[]=new int[3];
  int dis2[]=new int[3];
  Graphics virt;
  Image image;

  public void init()
  {
    setBackground(Color.white);
    setFont(font);
    setLayout(null);
    add(start); start.reshape(190,15,45,20);
    add(step); step.reshape(190,40,45,20);
    add(clear); clear.reshape(190,65,45,20);
    w=size().width; h=size().height;
    image=createImage(w,h);
    virt=image.getGraphics();
    for(i=0;i<16;++i)mem[i]=0;
    for(i=0;i<3;++i)dis[i]=255;
    pc=0; run=false; oneStep=false; zero=false; over=false; cx=0; cy=0;
    repaint();
  }

  public void start()
  {
    if(engine==null)
    {
      engine=new Thread(this);
      engine.start();
    }
  }

  public void stop()
  {
    if(engine!=null)
    {
      engine.stop();
      engine=null;
    }
  }

  public void run()
  {
    while(true)
    {
      int pause=1;
      if(((run)||(oneStep))&&(!zero))
      {
        if(!oneStep)pause=500;
        oneStep=false;
        switch ((mem[pc]>>12)&15)
        {
          case 0: mem[mem[pc]&15]=mem[(mem[pc]>>8)&15]; break;
          case 1: if(mem[(mem[pc]>>8)&15]+mem[(mem[pc]>>4)&15]<65536)mem[mem[pc]&15]=(mem[(mem[pc]>>8)&15]+mem[(mem[pc]>>4)&15])&65535; else{run=false; over=true;}break;
          case 2: if(mem[(mem[pc]>>4)&15]!=0) mem[mem[pc]&15]=(mem[(mem[pc]>>8)&15]/mem[(mem[pc]>>4)&15])&65535; else {run=false; zero=true;} break;
          case 3: mem[mem[pc]&15]=(mem[(mem[pc]>>8)&15]-mem[(mem[pc]>>4)&15])&65535; break;
          case 4: if(mem[(mem[pc]>>8)&15]==mem[(mem[pc]>>4)&15])pc=(mem[pc]&15)-1; break;
          case 5: if(mem[(mem[pc]>>8)&15]*mem[(mem[pc]>>4)&15]<65536)mem[mem[pc]&15]=(mem[(mem[pc]>>8)&15]*mem[(mem[pc]>>4)&15])&65535; else{run=false; over=true;}break;
          case 6: if(mem[(mem[pc]>>8)&15]>mem[(mem[pc]>>4)&15])pc=(mem[pc]&15)-1; break;
          case 7: dis[0]=(mem[pc]>>8)&15; dis[1]=(mem[pc]>>4)&15; dis[2]=mem[pc]&15; dis2[0]=mem[dis[0]]; dis2[1]=mem[dis[1]]; dis2[2]=mem[dis[2]]; run=false; repaint(); break;
        }
        repaint();
        ++pc; if(pc==16){run=false; pc=0;}
      }
       try{engine.sleep(pause);}
       catch(InterruptedException e) {}
    }
  }
  
  public boolean action(Event evt, Object arg)
  {
    if(evt.target instanceof Button)
    {
      zero=false;
      if(("Start".equals(arg))&&(!zero)) {run=true; pc=0;}
      if("Stop".equals(arg))run=false;
      if(!run)
      {
        if("Step".equals(arg))oneStep=true;
        if("Clear".equals(arg))
        {
          add(no); no.reshape(212,65,22,20);
          clear.setLabel("Y"); clear.reshape(190,65,22,20);
        }
      }
      if("Y".equals(arg))
      {
        zero=false; pc=0; cx=0; cy=0;
        for(i=0;i<16;++i)mem[i]=0;
        for(i=0;i<3;++i)dis[i]=255;
        repaint();
      }
      if(("N".equals(arg))||("Y".equals(arg)))
      {
        remove(no);
        clear.reshape(190,65,45,20);
        clear.setLabel("Clear");
      }
    }

    repaint();
    return(true);
  }
  
  public boolean mouseDown(Event evt,int x,int y)
  {
    if(!run)
    {
      zero=false;
      int line=(y-12)/12;
      if(line<16)
      {
        if(x<38) pc=line;
        else if(x<181)
        {
          int i,j,k;
          i=(x-45)/35;
          j=(3-i)*4+3-((x-(45+i*35))/7);
          cx=15-j; cy=line;
        }
      } 
      repaint();
    }
    return(true);
  }
  
  public boolean keyDown(Event evt, int key)
  {
    zero=false;
    if(!run)
    {
      if(key==48){mem[cy]=mem[cy]&((1<<(15-cx))^65535); ++cx; if(cx==16)++cy;}
      if(key==49){mem[cy]=mem[cy]|(1<<(15-cx)); ++cx; if(cx==16)++cy;}
      if(key==10){cx=0; ++cy;}
      if(key==1004)--cy; if(key==1005)++cy;
      if(key==1006)--cx; if(key==1007)++cx;
      if(key==1000)cx=0; if(key==1001)cx=15;
      if(key==1002)cy=0; if(key==1003)cy=15;
      cx=cx&15; cy=cy&15;
      repaint();
    }
    return(true);
  }

  public void paint(Graphics g)
  {
    update(g);
  }
  
  public void update(Graphics g)
  {
    if(run) start.setLabel("Stop");
      else start.setLabel("Start");

    virt.clearRect(0,0,w,h);

    virt.drawLine(0,12,180,12);
    virt.drawLine(38,0,38,205);
    virt.drawLine(38,218,38,255);
    virt.drawLine(0,205,180,205);
    virt.drawLine(0,218,180,218);
    virt.drawLine(0,255,180,255);
    virt.drawString("DISPLAY",5,216);
    virt.drawString("ADDR",5,10);
    virt.drawString("CODE",45,10);
    virt.drawString("A1",87,10);
    virt.drawString("A2",122,10);
    virt.drawString("A3",157,10);

    String hex;
    for(i=0;i<16;++i)virt.drawString(drawMem(mem[i]),45,23+i*12);
    virt.drawString("_",45+cx/4*35+cx%4*7,22+cy*12);

    for(i=0;i<3;++i)if(dis[i]!=255)
    {
      virt.drawString(""+dis2[i],1,229+i*12);
      virt.drawString(drawMem(dis2[i]),45,229+i*12);
    }

    for(i=0;i<16;++i)
    {
      if(i==pc)virt.setColor(Color.red);
        else virt.setColor(Color.black);
      virt.drawString(toBin(i),5,23+i*12);
    }

    virt.setColor(Color.red);
    if(zero)virt.drawString("Division by zero",45,241);
    if(over)virt.drawString("Overflow",45,241);
    virt.setColor(Color.black);
    
    g.drawImage(image,0,0,w,h,this);
    showStatus("(C) 2000 Gordeev Evgeny. eliter@chat.ru");
  }
  
  public String toBin(int b)
  {
    String bin="";
    int i;
    for(i=0;i<4;++i)
    {
      if(b%16-b%8!=0)bin=bin+1;
      else bin=bin+0;
      b=b<<1;
    }
    return(bin);
  }

  public String drawMem(int n)
  {
    String bin="";
    int i=n,j;
    for(j=0;j<4;++j)bin=bin+toBin((i>>(3-j)*4)&15)+" ";
    return(bin);
  }
}
